class MSCUDate : public MSCUObject
{
public:
	
	MSCUDate();

	// Standard framework File I/O
	virtual void SaveToFile( ostream& O );
	virtual void LoadFromFile( istream& O );

	// Standard framework string interaction
	virtual const string GetAsString() const;
	virtual void SetFromString( const string& Src );
	
	// Standard framework object management
	virtual int Compare( const MSCUObject& Src) const;
	virtual MSCUObject* Clone() const;

	// Functions unique to this class
	static bool InitTodaysDate( bool Mode );
	static bool Output4Digits( bool Mode );
	static char Seperator( char NewSep );
	int GetMonth() const ;
	int GetDay() const;
	int Year() const;
	const char* GetMonthName() const;
private:
	static bool InitToday, FourDigit;
	static char Sep;
	char M, D;
	short int Y;
};
