#include <iostream>
#include <string>
using namespace std;

class MSCUObject
{
public:
#ifndef MSNDEBUG
	MSCUObject() { MSCUObjectCount++; }
	virtual ~MSCUObject() { MSCUObjectCount--; }	// Fix: Note 'virtual'
#endif
#ifdef MSNDEBUG
	virtual ~MSCUObject() { }	// Fix: Note 'virtual'
#endif
	const virtual char *GetType() const { return( "MSObject" ); }

	virtual void SaveToFile(ostream& O) const { throw "Unimplemented feature"; }
	virtual void LoadFromFile(istream& i) { throw "Unimplemented feature";}

	virtual void SetFromString( string& Src ) { throw "Unimplemented feature"; }
	virtual const string GetAsString() const { throw "Unimplemented feature"; return(0);}

	// Added in version 2
	virtual int Compare( const MSCUObject& Src) const { return( GetAsString().compare(Src.GetAsString()));}
	virtual int operator==( const MSCUObject& Src ) const { return( Compare( Src )==0 );}
	virtual int operator<=( const MSCUObject& Src ) const { return( Compare( Src )<=0 );}
	virtual int operator>=( const MSCUObject& Src ) const { return( Compare( Src )>=0 );}
	virtual int operator<( const MSCUObject& Src ) const { return( Compare( Src )<0 );}
	virtual int operator>( const MSCUObject& Src ) const { return( Compare( Src )>0 );}
	virtual MSCUObject& operator=( const MSCUObject& Src ) { SetFromString( Src.GetAsString() ); return(*this); }
	virtual MSCUObject* Clone() const { throw "Unimplemented feature"; return(0);}
	
#ifndef MSNDEBUG
	static int GetCount() { return( MSCUObjectCount ); }
#endif
private:
#ifndef MSNDEBUG
	static int MSCUObjectCount;
#endif
};

ostream& operator<<( ostream& O, const MSCUObject& MSO );

#include "mscudate.h"
#include "mscussn.h"

